:-dynamic counter/1.

counter(68).
unit(11).

runme1:- gohexor.    % runme1 - pierwszy wątek wykonania
runme2.  	     % runme2 - drugi wątek wykonania ( w tym przypadku zaraz się zakończy ) 
		     % tylko jeden wątek może obsługiwać komunikację z robotem !!!!!

start:-         unit(U),cameraOn(U),camera(U,68,240),sensors.

sensors:- 	counter(T),T > 240, retract(counter(_)),assert(counter(68)),!,sensors.
sensors:-       unit(U),counter(T),X is T + 10, retract(counter(_)),assert(counter(X)),camera(U,X,240),
                readSensors(U,A,B),
                readIR(U,C),
                write('temp: '),write(A),
                write(' sonar: '),write(B),
                write(' ir: '),write(C),
                nl,
		!,delay(1),sensors.

onestep(U):-    forward(U),stop(U).
gohexor:- 	unit(U),cameraOn(U),forward(U),writeln('forward'),delay(5),
		backward(U),writeln('backward'),delay(5),
		left(U),writeln('left'),delay(5),stop(U),
		camera(U,190,240), readSensors(U,A,B),
		write('temp: '),write(A),
                write(' sonar: '),write(B),nl,
		right(U),writeln('right'),delay(5),
		forward(U),writeln('forward'),delay(5),
		stop(U),writeln('stop'),writeln('DONE'),onestep(U),cameraOff(U).
gohexor:- 	writeln('ERROR'),unit(U),stop(U),cameraOff(U).



