
#ifndef HEXOR_H
#define HEXOR_H

void calculateCRC(unsigned char *frame);
int sendCommand(unsigned char *frame);
void printFrame(unsigned char *frame);
int forward(unsigned char unit);
int backward(unsigned char unit);
int tleft(unsigned char unit);
int tright(unsigned char unit);
int stop(unsigned char unit);
int camera(unsigned char unit, long x, long y);
int cameraOnOff(unsigned char unit, int state);
int read_sensors(unsigned char unit, long *temp, long *sonar);
int read_ir(unsigned char unit, unsigned char *ir);

#endif
